var zoneScript = "zone.php";
var NOAA = {};
NOAA.mapURLs = [];
NOAA.mapURLs[16] = "http://www.nws.noaa.gov/satellite_images/list24.txt";

//Forecasts
NOAA.mapURLs[69] = "http://www.weather.gov/forecasts/graphical/images/conus/Wx$$_conus.png";
NOAA.mapURLs[70] = "http://www.weather.gov/forecasts/graphical/images/northeast/Wx$$_northeast.png";
NOAA.mapURLs[71] = "http://www.weather.gov/forecasts/graphical/images/midatlantic/Wx$$_midatlantic.png";
NOAA.mapURLs[72] = "http://www.weather.gov/forecasts/graphical/images/southeast/Wx$$_southeast.png";
NOAA.mapURLs[73] = "http://www.weather.gov/forecasts/graphical/images/northplains/Wx$$_northplains.png";
NOAA.mapURLs[74] = "http://www.weather.gov/forecasts/graphical/images/centplains/Wx$$_centplains.png";
NOAA.mapURLs[75] = "http://www.weather.gov/forecasts/graphical/images/southplains/Wx$$_southplains.png";
NOAA.mapURLs[76] = "http://www.weather.gov/forecasts/graphical/images/pacnorthwest/Wx$$_pacnorthwest.png";
NOAA.mapURLs[77] = "http://www.weather.gov/forecasts/graphical/images/pacsouthwest/Wx$$_pacsouthwest.png";
NOAA.mapURLs[78] = "http://www.weather.gov/forecasts/graphical/images/pacsouthwest/Wx$$_pacsouthwest.png";

// Temps
NOAA.mapURLs[79] = "http://www.weather.gov/forecasts/graphical/images/northeast/T$$_northeast.png";
NOAA.mapURLs[80] = "http://www.weather.gov/forecasts/graphical/images/midatlantic/T$$_midatlantic.png";
NOAA.mapURLs[81] = "http://www.weather.gov/forecasts/graphical/images/southeast/T$$_southeast.png";
NOAA.mapURLs[82] = "http://www.weather.gov/forecasts/graphical/images/northplains/T$$_northplains.png";
NOAA.mapURLs[83] = "http://www.weather.gov/forecasts/graphical/images/centplains/T$$_centplains.png";
NOAA.mapURLs[84] = "http://www.weather.gov/forecasts/graphical/images/southplains/T$$_southplains.png";
NOAA.mapURLs[85] = "http://www.weather.gov/forecasts/graphical/images/pacnorthwest/T$$_pacnorthwest.png";
NOAA.mapURLs[86] = "http://www.weather.gov/forecasts/graphical/images/pacsouthwest/T$$_pacsouthwest.png";
NOAA.mapURLs[87] = "http://www.weather.gov/forecasts/graphical/images/pacsouthwest/T$$_pacsouthwest.png";

// Wind
NOAA.mapURLs[88] = "http://www.weather.gov/forecasts/graphical/images/northeast/WindSpd$$_northeast.png";
NOAA.mapURLs[89] = "http://www.weather.gov/forecasts/graphical/images/midatlantic/WindSpd$$_midatlantic.png";
NOAA.mapURLs[90] = "http://www.weather.gov/forecasts/graphical/images/southeast/WindSpd$$_southeast.png";
NOAA.mapURLs[91] = "http://www.weather.gov/forecasts/graphical/images/northplains/WindSpd$$_northplains.png";
NOAA.mapURLs[92] = "http://www.weather.gov/forecasts/graphical/images/centplains/WindSpd$$_centplains.png";
NOAA.mapURLs[93] = "http://www.weather.gov/forecasts/graphical/images/southplains/WindSpd$$_southplains.png";
NOAA.mapURLs[94] = "http://www.weather.gov/forecasts/graphical/images/pacnorthwest/WindSpd$$_pacnorthwest.png";
NOAA.mapURLs[95] = "http://www.weather.gov/forecasts/graphical/images/pacsouthwest/WindSpd$$_pacsouthwest.png";
NOAA.mapURLs[96] = "http://www.weather.gov/forecasts/graphical/images/pacsouthwest/WindSpd$$_pacsouthwest.png";

// Alerts
var alerts = {};
alerts["Significant Weather Advisory"] = {level: 1, fg: "#000000", bg: "#ffff00"};
alerts["Air Stagnation Advisory"] = {level: 1, fg: "#000000", bg: "#00ffff"};
alerts["Dense Smoke Advisory"] = {level: 1, fg: "#000000", bg: "#00ffff"};
alerts["Blowing Dust Advisory"] = {level: 1, fg: "#000000", bg: "#00ffff"};
alerts["Snow Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Blowing Snow Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Snow and Blowing Snow Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Freezing Rain/Drizzle Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Sleet Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Winter Weather Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Frost Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Wind Chill Advisory"] = {level: 1, fg: "#000000", bg: "#ffffff"};
alerts["Flood Advisory"] = {level: 1, fg: "#000000", bg: "#00ff00"};
alerts["Dense Fog Advisory"] = {level: 1, fg: "#000000", bg: "#00ffff"};
alerts["Wind Advisory"] = {level: 1, fg: "#000000", bg: "#00ffff"};
alerts["Heat Advisory"] = {level: 1, fg: "#000000", bg: "#990000"};
alerts["Fire Weather Watch"] = {level: 2, fg: "#000000", bg: "#990000"};
alerts["Dust Storm Warning"] = {level: 2, fg: "#000000", bg: "#00ffff"};
alerts["Red Flag Warning"] = {level: 2, fg: "#000000", bg: "#00ffff"};
alerts["Freeze Warning"] = {level: 3, fg: "#000000", bg: "#ffffff"};
alerts["High Wind Warning"] = {level: 3, fg: "#000000", bg: "#00ffff"};
alerts["Wind Chill Warning"] = {level: 3, fg: "#000000", bg: "#ffffff"};
alerts["Coastal Flood Watch"] = {level: 3, fg: "#000000", bg: "#00ff00"};
alerts["Flood Watch"] = {level: 4, fg: "#000000", bg: "#00ff00"};
alerts["Flash Flood Watch"] = {level: 4, fg: "#000000", bg: "#00ff00"};
alerts["Excessive Heat Warning"] = {level: 4, fg: "#000000", bg: "#990000"};
alerts["Severe Thunderstorm Watch"] = {level: 5, fg: "#000000", bg: "#ffff00"};
alerts["Tropical Storm Watch"] = {level: 5, fg: "#000000", bg: "#ffff00"};
alerts["Tornado Watch"] = {level: 6, fg: "#000000", bg: "#ff0000"};
alerts["Hurricane Watch"] = {level: 6, fg: "#000000", bg: "#ff0000"};
alerts["Flash Flood Warning"] = {level: 6, fg: "#000000", bg: "#00ff00"};
alerts["Ice Storm Warning"] = {level: 6, fg: "#000000", bg: "#ffffff"};
alerts["Heavy Sleet Warning"] = {level: 6, fg: "#000000", bg: "#ffffff"};
alerts["Heavy Snow Warning"] = {level: 6, fg: "#000000", bg: "#ffffff"};
alerts["Severe Thunderstorm Warning"] = {level: 7, fg: "#000000", bg: "#ffff00"};
alerts["Winter Storm Warning"] = {level: 7, fg: "#000000", bg: "#ffffff"};
alerts["Blizzard Warning"] = {level: 8, fg: "#000000", bg: "#ffffff"};
alerts["Tropical Storm Warning"] = {level: 8, fg: "#000000", bg: "#ffff00"};
alerts["Tornado Warning"] = {level: 9, fg: "#000000", bg: "#ff0000"};
alerts["Hurricane Warning"] = {level: 9, fg: "#000000", bg: "#ff0000"};

NOAA.getAlerts = function(mapObj) {
  var zone = "";

  var zonesURL = "http://www.dividedsoul.net/RadarInMotion/maps/" + zoneScript + "?zipcode=" + mapObj.regioncode;
  var zoneRequest = null;
  zoneRequest = new XMLHttpRequest();
  zoneRequest.open("GET", zonesURL, false);
  zoneRequest.send(null);
  if (zoneRequest.readyState != 4 || zoneRequest.status != 200) {
    return;
  }
  zone = zoneRequest.responseText;

  if (zone == "") {
    return;
  }

  var toAlertsURL = "https://alerts.weather.gov/cap/wwaatmget.php?x=" + zone + "&y=0";
  var alertRequest = null;
  alertRequest = new XMLHttpRequest();
  alertRequest.open("POST", toAlertsURL.replace(/\0+$/, ''), false);
  alertRequest.send(null);
  if (alertRequest.readyState == 4 && alertRequest.status == 200) {
    // All warnings are included in <div> tag with class "hazardous-conditions"
    var alertsPage = document.implementation.createHTMLDocument("");
    alertsPage.open();
    alertsPage.write(alertRequest.responseText);
    mapObj.urlRequest = null;
    var events = alertsPage.getElementsByTagName("cap:event");
    var warningLevel = -1;
    var couldBeWarnings = true;
    for (var i = 0; i < events.length && couldBeWarnings; i++) {
      alertText = events[i].innerHTML;
      var nextAlert = alerts[alertText];
      if (nextAlert == null && warningLevel < 1) {
        warningLevel = 1;
        mapObj.alert.color = "#000000";
        mapObj.alert.background = "#cccccc";
        mapObj.alert.innerHTML = alertText;
      } else if (nextAlert != null && nextAlert.level > warningLevel) {
        warningLevel = nextAlert.level;
        mapObj.alert.color = nextAlert.fg;
        mapObj.alert.background = nextAlert.bg;
        mapObj.alert.innerHTML = alertText;
      }
    }
    if (warningLevel == -1) mapObj.alert.innerHTML = null;
  }

};

NOAA.getURLS = function(mapObj) {
  // Map is at a specific location
  if (mapObj.map == 0) {
    mapObj.getPageWithMap();
  }

  // Map is regional
  else {
    mapObj.mapOptions[0] = [];
    mapObj.mapOptions[0][0] = null;
    mapObj.mapOptions[0][1] = NOAA.mapURLs[mapObj.map];
  }
  document.getElementById("weatherURL").visibility = "hidden";
};

NOAA.getPageWithMap = function(mapObj) {
  var searchPage = "http://www.dividedsoul.net/RadarInMotion/fetch.php?zipcode=" + mapObj.regioncode;
  var tableZip = null;
  var findRequest = null;
  findRequest = new XMLHttpRequest();
  findRequest.open("GET", searchPage, false);
  findRequest.send(null);

  try {
    var stationID = null;
    if (findRequest.readyState == 4 && findRequest.status == 200) {
      // All warnings are included in <td> tag with class "module"
      var hrefText = findRequest.responseText.split("\n");
      if (hrefText.length == 3) {
        var latitude = hrefText[1];
        var longitude = hrefText[2];
        var closest = 1000000;
        for (i = 0; i < NOAA.Stations.length; i++) {
          var distance = Math.sqrt(Math.pow(latitude - NOAA.Stations[i][1], 2) + Math.pow(longitude - NOAA.Stations[i][2], 2));
          if (distance < closest) {
            closest = distance;
            stationID = NOAA.Stations[i][0];
          }
        }
      }
    }

    if (stationID) {
      var mapsURL = stationID;
      mapObj.mapOptions[0] = [];
      mapObj.mapOptions[0][0] = "Short";
      mapObj.mapOptions[1] = [];
      mapObj.mapOptions[1][0] = "Long";
      mapObj.mapOptions[0][1] = "http://radar.weather.gov/ridge/RadarImg/NCR/" + mapsURL;
      mapObj.mapOptions[1][1] = "http://radar.weather.gov/ridge/RadarImg/N0Z/" + mapsURL;
      mapObj.underlays[0] = [];
      mapObj.underlays[1] = [];
      if (actualSaveMaps > 0) {
        var nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".jpg\" " + "http://radar.weather.gov/Overlays/Topo/Short/" + mapsURL + "_Topo_Short.jpg", null);
        mapObj.underlays[0][0] = folder + "/" + nextTime + ".jpg";
        nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".gif\" " + "http://radar.weather.gov/Overlays/County/Short/" + mapsURL + "_County_Short.gif", null);
        mapObj.underlays[0][1] = folder + "/" + nextTime + ".gif";
        nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".gif\" " + "http://radar.weather.gov/Overlays/Highways/Short/" + mapsURL + "_Highways_Short.gif", null);
        mapObj.underlays[0][2] = folder + "/" + nextTime + ".gif";
        nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".gif\" " + "http://radar.weather.gov/Overlays/Cities/Short/" + mapsURL + "_City_Short.gif", null);
        mapObj.underlays[0][3] = folder + "/" + nextTime + ".gif";

        nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".jpg\" " + "http://radar.weather.gov/Overlays/Topo/Long/" + mapsURL + "_Topo_Long.jpg", null);
        mapObj.underlays[1][0] = folder + "/" + nextTime + ".jpg";
        nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".gif\" " + "http://radar.weather.gov/Overlays/County/Long/" + mapsURL + "_County_Long.gif", null);
        mapObj.underlays[1][1] = folder + "/" + nextTime + ".gif";
        nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".gif\" " + "http://radar.weather.gov/Overlays/Highways/Long/" + mapsURL + "_Highways_Long.gif", null);
        mapObj.underlays[1][2] = folder + "/" + nextTime + ".gif";
        nextTime = (new Date()).getTime();
        widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + nextTime +
          ".gif\" " + "http://radar.weather.gov/Overlays/Cities/Long/" + mapsURL + "_City_Long.gif", null);
        mapObj.underlays[1][3] = folder + "/" + nextTime + ".gif";

      } else {


        mapObj.underlays[0][0] = "http://radar.weather.gov/Overlays/Topo/Short/" + mapsURL + "_Topo_Short.jpg";
        mapObj.underlays[0][1] = "http://radar.weather.gov/Overlays/County/Short/" + mapsURL + "_County_Short.gif";
        mapObj.underlays[0][2] = "http://radar.weather.gov/Overlays/Highways/Short/" + mapsURL + "_Highways_Short.gif";
        mapObj.underlays[0][3] = "http://radar.weather.gov/Overlays/Cities/Short/" + mapsURL + "_City_Short.gif";


        mapObj.underlays[1][0] = "http://radar.weather.gov/Overlays/Topo/Long/" + mapsURL + "_Topo_Long.jpg";
        mapObj.underlays[1][1] = "http://radar.weather.gov/Overlays/County/Long/" + mapsURL + "_County_Long.gif";
        mapObj.underlays[1][2] = "http://radar.weather.gov/Overlays/Highways/Long/" + mapsURL + "_Highways_Long.gif";
        mapObj.underlays[1][3] = "http://radar.weather.gov/Overlays/Cities/Long/" + mapsURL + "_City_Long.gif";
      }
    } else if (mapObj.urlRequest.readyState == 4) {
      if (mapObj.urlRequest.status == 404 || mapObj.urlRequest.status == -1009) {
        mapObj.alert.visibility = "visible";
        mapObj.alert.background = "#283f8d";
        mapObj.alert.innerHTML = "Warning: Map could not be loaded";
        document.getElementById("weatherURL").style.visibility = "hidden";
        document.getElementById("status").style.visibility = "hidden";
      }
      mapObj.urlRequest.abort();
      mapObj.urlRequest = null;
    }
  } catch (exception) {
    alert("Failed to load URL: " + exception);
  }
};

NOAA.getOtherMaps = function(mapObj) {};

NOAA.getMapID = function(city) {
  var splitStr = city.split(",", 2);
  if (splitStr[0] == null && splitStr[1] == null)
    return null;
  city = splitStr[0];
  var state = null;
  if (splitStr[1] != null)
    state = splitStr[1];

  var searchPage = "http://www.dividedsoul.net/RadarInMotion/fetch.php?city=" + city.replace(/^\s+|\s+$/g, "") + "&state=" + state.replace(/^\s+|\s+$/g, "");
  var tableZip = null;
  var findRequest = null;
  findRequest = new XMLHttpRequest();
  findRequest.open("GET", searchPage, false);
  findRequest.send(null);
  if (findRequest.readyState == 4 && findRequest.status == 200) {
    // All warnings are included in <td> tag with class "module"
    var hrefText = findRequest.responseText.split("\n");
    if (hrefText.length > 1)
      tableZip = hrefText[0];

  }
  return tableZip;
};

NOAA.getMaps = function(mapObj) {
  if (mapObj.mapOptions.length == 0 && !mapObj.cannotBeDisplayed) {
    document.getElementById("warning").style.visibility = "visible";
    document.getElementById("warning").style.background = "#283f8d";
    document.getElementById("warning").innerHTML = "Warning: Map could not be loaded";
    document.getElementById("weatherURL").style.visibility = "hidden";
    document.getElementById("status").style.visibility = "hidden";
  } else if (!mapObj.cannotBeDisplayed && mapObj.map < 69) {
    mapObj.urlRequest = new XMLHttpRequest();
    mapObj.urlRequest.open("GET", mapObj.mapOptions[mapObj.currentMap][1], false);
    var startURL = (mapObj.map == 0) ? "http://radar.weather.gov/" : ((mapObj.map == 1) ? "http://weather.noaa.gov/radar/" : "http://www.nws.noaa.gov/");
    var cutoffTime = 0;
    if (mapObj.underlays.length == 0) {
      var subsetIndex = (mapObj.map == 16) ? 0 : 6;
      mapObj.urlRequest.send(null);
      if (mapObj.urlRequest.readyState == 4 && mapObj.urlRequest.status == 200) {
        var mapURLSArray = mapObj.urlRequest.responseText.split('\n');
        mapObj.urlRequest = null;
        if (actualSaveMaps > 0) {
          cutoffTime = mapObj.lastUpdated == null ? "" : ("-z \"" + (mapObj.lastUpdated.toGMTString()) + "\" ");
          //alert("Last Time: " + cutoffTime);
          for (k = 0; k < mapURLSArray.length - 1; k++) {
            //alert( url + i + "L.jpg" + uniquei);
            var nextTime = (new Date()).getTime();
            //alert("GETTING " + startURL + mapURLSArray[k].substring(subsetIndex,mapURLSArray[k].length));
            var index = widget.system("/usr/bin/curl " + cutoffTime + "-o \"" + folder + "/" + nextTime +
              ".jpg\" " + startURL + mapURLSArray[k].substring(subsetIndex, mapURLSArray[k].length), null).errorString.indexOf("100");
            //alert("CHECKING " + i + ": " + widget.system("/usr/bin/curl -I "  +  url + "5L.jpg" + uniquei,null).outputString.split("\n")[3].substring(15));
            if (index > -1) {
              //alert("STORING " + folder + "/" + nextTime + ".jpg" + " AT " + mapObj.maps.length);
              mapObj.maps[mapObj.maps.length] = folder + "/" + nextTime + ".jpg";
            }
            document.getElementById("warning").innerHTML = "Loading Maps: " + (k + 1) + "/10";
          }



          // Last updated is last modified date of most recent map
          //alert("GETTING " + startURL + mapURLSArray[mapURLSArray.length-2].substring(subsetIndex,mapURLSArray[k].length));
          mapObj.lastUpdated = new Date(widget.system("/usr/bin/curl -I " + startURL + mapURLSArray[mapURLSArray.length - 2].substring(subsetIndex, mapURLSArray[mapURLSArray.length - 2].length), null).outputString.split("\n")[3].substring(15));
          //alert("Last updated: " + lastUpdated);
          // Remove old maps
          mapObj.removeOldMaps();

        } else
          for (k = 0; k < mapURLSArray.length - 1; k++) {
            mapObj.maps[k] = startURL + mapURLSArray[k].substring(subsetIndex, mapURLSArray[k].length);
            //alert(startURL + mapURLSArray[k].substring(subsetIndex,mapURLSArray[k].length));
          }
        if (mapObj.map == 0 && actualShowAlerts) mapObj.getAlerts();
      }
    }
    // New RIDGE Map
    else {
      mapObj.urlRequest.send(null);
      if (mapObj.urlRequest.readyState == 4 && mapObj.urlRequest.status == 200) {
        var arrayOfMapURLS = mapObj.urlRequest.responseText.split('\n');
        arrayOfMapURLS.splice(arrayOfMapURLS.length - 4, 4);
        if (arrayOfMapURLS.length - 10 > 10) arrayOfMapURLS.splice(0, arrayOfMapURLS.length - 10);
        else arrayOfMapURLS.splice(0, 8);
        cutoffTime = mapObj.lastUpdated == null ? "" : ("-z \"" + (mapObj.lastUpdated.toGMTString()) + "\" ");
        for (k = 0; k < arrayOfMapURLS.length; k++) {
          if (arrayOfMapURLS[k].substring(80, 105).length == 0) {
            continue;
          }
          if (actualSaveMaps == 0) {
            mapObj.maps[k] = mapObj.mapOptions[mapObj.currentMap][1] + "/" + arrayOfMapURLS[k].substring(80, 105);
            mapObj.legends[k] = mapObj.mapOptions[mapObj.currentMap][1].replace("RadarImg", "Legend") + "/" + arrayOfMapURLS[k].substring(80, 105).replace(".gif", "_Legend.gif");
          } else {
            widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + arrayOfMapURLS[k].substring(80, 105) +
              "\" " + mapObj.mapOptions[mapObj.currentMap][1] + "/" + arrayOfMapURLS[k].substring(80, 105), null);
            if (mapObj.lastUpdated == null || NOAA.filenameToTime(arrayOfMapURLS[k].substring(80, 105)) > mapObj.lastUpdated) {
              mapObj.maps[mapObj.maps.length] = folder + "/" + arrayOfMapURLS[k].substring(80, 105);
              widget.system("/usr/bin/curl " + "-o \"" + folder + "/" + arrayOfMapURLS[k].substring(80, 105).replace(".gif", "_Legend.gif") +
                "\" " + mapObj.mapOptions[mapObj.currentMap][1].replace("RadarImg", "Legend") + "/" + arrayOfMapURLS[k].substring(80, 105).replace(".gif", "_Legend.gif"), null);
              mapObj.legends[mapObj.legends.length] = folder + "/" + arrayOfMapURLS[k].substring(80, 105).replace(".gif", "_Legend.gif");
              //alert(mapObj.legends[mapObj.legends.length-1]);
              //alert(mapObj.maps[mapObj.maps.length-1]);
            }
            document.getElementById("warning").innerHTML = "Loading Maps: " + (k + 1) + "/10";
            mapObj.removeOldMaps();
          }
        }
        mapObj.lastUpdated = NOAA.filenameToTime(mapObj.maps[mapObj.maps.length - 1]);
        if (mapObj.map == 0 && actualShowAlerts) mapObj.getAlerts();
      }


    }
  } else if (!mapObj.cannotBeDisplayed) {
    for (k = 0; k < 25; k++) {
      mapObj.maps[k] = NOAA.mapURLs[mapObj.map].replace("$$", 2 * k + 1);
      //alert(mapObj.maps[k]);
      //alert(startURL + mapURLSArray[k].substring(subsetIndex,mapURLSArray[k].length));
    }
  }

};

NOAA.filenameToTime = function(file) {

  var asDate = new Date();
  if (!file)
    return asDate;
  var fileLength = file.length;
  asDate.setFullYear(file.substring(fileLength - 21, fileLength - 17), file.substring(fileLength - 17, fileLength - 15) - 1, file.substring(fileLength - 15, fileLength - 13));
  asDate.setHours(file.substring(fileLength - 12, fileLength - 10));
  asDate.setMinutes(file.substring(fileLength - 10, fileLength - 8));
  //alert(asDate);
  return asDate;
};

NOAA.Stations = [
  ["ABC", 60.79194444, -161.8763889],
  ["ABR", 45.45583333, -98.41305556],
  ["ABX", 35.14972222, -106.8238889],
  ["ACG", 56.85277778, -135.5291667],
  ["AEC", 64.49611111, -165.3183333],
  ["AHG", 60.72583333, -151.3513889],
  ["AIH", 59.46138889, -146.3030556],
  ["AKC", 58.67944444, -156.6294444],
  ["AKQ", 36.98388889, -77.00722222],
  ["AMA", 35.23333333, -101.7091667],
  ["AMX", 25.61111111, -80.41277778],
  ["APD", 65.035, -147.5016667],
  ["APX", 44.90722222, -84.71972222],
  ["ARX", 43.82277778, -91.19111111],
  ["ATX", 48.19444444, -122.4958333],
  ["BBX", 39.49611111, -121.6316667],
  ["BGM", 42.19972222, -75.98472222],
  ["BHX", 40.49833333, -124.2919444],
  ["BIS", 46.77083333, -100.7605556],
  ["BLX", 45.85388889, -108.6066667],
  ["BMX", 33.17222222, -86.76972222],
  ["BOX", 41.95583333, -71.13694444],
  ["BRO", 25.91611111, -97.41888889],
  ["BUF", 42.94888889, -78.73666667],
  ["BYX", 24.5975, -81.70305556],
  ["CAE", 33.94861111, -81.11833333],
  ["CBW", 46.03916667, -67.80638889],
  ["CBX", 43.49055556, -116.2355556],
  ["CCX", 40.92305556, -78.00361111],
  ["CLE", 41.41305556, -81.85972222],
  ["CLX", 32.65555556, -81.04194444],
  ["CRP", 27.78416667, -97.51111111],
  ["CXX", 44.51111111, -73.16694444],
  ["CYS", 41.15194444, -104.8061111],
  ["DAX", 38.50111111, -121.6777778],
  ["DDC", 37.76083333, -99.96888889],
  ["DFX", 29.27277778, -100.2805556],
  ["DIX", 39.94694444, -74.41083333],
  ["DLH", 46.83694444, -92.20972222],
  ["DMX", 41.73138889, -93.72277778],
  ["DOX", 38.82555556, -75.43972222],
  ["DTX", 42.69972222, -83.47166667],
  ["DVN", 41.61166667, -90.58083333],
  ["DYX", 32.53833333, -99.25444444],
  ["EAX", 38.81027778, -94.26444444],
  ["EMX", 31.89361111, -110.6302778],
  ["ENX", 42.58638889, -74.06388889],
  ["EOX", 31.46055556, -85.45944444],
  ["EPZ", 31.87305556, -106.6980556],
  ["ESX", 35.70111111, -114.8913889],
  ["EVX", 30.56444444, -85.92138889],
  ["EWX", 29.70388889, -98.02833333],
  ["EYX", 35.09777778, -117.5608333],
  ["FCX", 37.02444444, -80.27388889],
  ["FDR", 34.36222222, -98.97638889],
  ["FDX", 34.63527778, -103.63],
  ["FFC", 33.36361111, -84.56583333],
  ["FSD", 43.58777778, -96.72944444],
  ["FSX", 34.57444444, -111.1977778],
  ["FTG", 39.78666667, -104.5458333],
  ["FWS", 32.57305556, -97.30305556],
  ["GGW", 48.20638889, -106.625],
  ["GJX", 39.06222222, -108.2138889],
  ["GLD", 39.36694444, -101.7002778],
  ["GRB", 44.49833333, -88.11138889],
  ["GRK", 30.72194444, -97.38305556],
  ["GRR", 42.89388889, -85.54472222],
  ["GSP", 34.88333333, -82.22],
  ["GUA", 13.4525, 144.8113889],
  ["GWX", 33.89666667, -88.32888889],
  ["GYX", 43.89138889, -70.25666667],
  ["HDX", 33.07638889, -106.1227778],
  ["HGX", 29.47194444, -95.07916667],
  ["HKI", 21.89416667, -159.5522222],
  ["HKM", 20.09444444, -155.7469444],
  ["HMO", 21.13277778, -157.18],
  ["HNX", 36.31416667, -119.6322222],
  ["HPX", 36.73666667, -87.285],
  ["HTX", 34.93055556, -86.08333333],
  ["HWA", 19.095, -155.5688889],
  ["ICT", 37.65472222, -97.44277778],
  ["ICX", 37.59083333, -112.8622222],
  ["ILN", 39.42027778, -83.82166667],
  ["ILX", 40.15055556, -89.33694444],
  ["IND", 39.7075, -86.28027778],
  ["INX", 36.175, -95.56472222],
  ["IWA", 33.28916667, -111.67],
  ["IWX", 41.35888889, -85.7],
  ["JAX", 30.48472222, -81.70194444],
  ["JGX", 32.67527778, -83.35111111],
  ["JKL", 37.59083333, -83.31305556],
  ["JUA", 18.11555556, -66.07805556],
  ["LBB", 33.65416667, -101.8141667],
  ["LCH", 30.12527778, -93.21583333],
  ["LIX", 30.33666667, -89.82555556],
  ["LNX", 41.95777778, -100.5763889],
  ["LOT", 41.60472222, -88.08472222],
  ["LRX", 40.73972222, -116.8027778],
  ["LSX", 38.69888889, -90.68277778],
  ["LTX", 33.98944444, -78.42888889],
  ["LVX", 37.97527778, -85.94388889],
  ["LWX", 58.53805556, -28.68972222],
  ["LZK", 34.83666667, -92.26222222],
  ["MAF", 31.94333333, -102.1891667],
  ["MAX", 42.08111111, -122.7172222],
  ["MBX", 48.3925, -100.865],
  ["MHX", 34.77611111, -76.87611111],
  ["MKX", 42.96777778, -88.55055556],
  ["MLB", 28.11333333, -80.65416667],
  ["MOB", 30.67944444, -88.23972222],
  ["MPX", 44.84888889, -93.56555556],
  ["MQT", 46.53111111, -87.54833333],
  ["MRX", 36.16861111, -83.40166667],
  ["MSX", 47.04111111, -113.9861111],
  ["MTX", 41.26277778, -112.4477778],
  ["MUX", 37.15527778, -121.8983333],
  ["MVX", 47.52777778, -97.32555556],
  ["MXX", 32.53666667, -85.78972222],
  ["NKX", 32.91888889, -117.0419444],
  ["NQA", 35.34472222, -89.87333333],
  ["OAX", 41.32027778, -96.36666667],
  ["OHX", 36.24722222, -86.5625],
  ["OKX", 40.86555556, -72.86388889],
  ["OTX", 47.68027778, -117.6266667],
  ["PAH", 37.06833333, -88.77194444],
  ["PBZ", 40.53166667, -80.21805556],
  ["PDT", 45.69055556, -118.8527778],
  ["POE", 31.15555556, -92.97583333],
  ["PUX", 38.45944444, -104.1813889],
  ["RAX", 35.66555556, -78.48972222],
  ["RGX", 39.75416667, -119.4622222],
  ["RIW", 43.06611111, -108.4772222],
  ["RLX", 38.31111111, -81.72305556],
  ["RMX", 43.46777778, -75.45777778],
  ["RTX", 45.71472222, -122.9652778],
  ["SFX", 43.10583333, -112.6861111],
  ["SGF", 37.23527778, -93.40055556],
  ["SHV", 32.45083333, -93.84138889],
  ["SJT", 31.37138889, -100.4925],
  ["SOX", 33.81722222, -117.6358333],
  ["SRX", 34.43444444, -93.90027778],
  ["TBW", 27.70555556, -82.40166667],
  ["TFX", 47.45972222, -111.3852778],
  ["TLH", 30.3975, -84.32888889],
  ["TLX", 35.33305556, -97.27777778],
  ["TWX", 38.99694444, -96.2325],
  ["UDX", 44.125, -102.8297222],
  ["UEX", 40.32083333, -98.44194444],
  ["VAX", 30.89138889, -83.00555556],
  ["VBX", 34.83805556, -120.3969444],
  ["VNX", 36.74083333, -98.12777778],
  ["VTX", 34.41166667, -119.1797222],
  ["YUX", 32.49527778, -114.6566667]
];
